/*
 * ALSA SoC OMAP ABE driver
*
 * Author:          Laurent Le Faucheur <l-le-faucheur@ti.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * version 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA
 *
 */
#ifndef _ABE_INITXXX_LABELS_H_
#define _ABE_INITXXX_LABELS_H_

#define Dummy_Regs_labelID                                  0
#define Dummy_AM_labelID                                    1
#define Voice_8k_UL_labelID                                 2
#define Voice_8k_DL_labelID                                 3
#define ECHO_REF_8K_labelID                                 4
#define Voice_16k_UL_labelID                                5
#define Voice_16k_DL_labelID                                6
#define ECHO_REF_16K_labelID                                7
#define MM_DL_labelID                                       8
#define IO_VX_DL_ASRC_labelID                               9
#define IO_MM_DL_ASRC_labelID                               10
#define IO_VIBRA_DL_labelID                                 11
#define ZERO_labelID                                        12
#define GTarget_labelID                                     13
#define GCurrent_labelID                                    14
#define Gr_1_labelID                                        15
#define Gr_2_labelID                                        16
#define Gr_Regs_labelID                                     17
#define DMIC0_Gain_labelID                                  18
#define DMIC1_Gain_labelID                                  19
#define DMIC2_Gain_labelID                                  20
#define DMIC3_Gain_labelID                                  21
#define AMIC_Gain_labelID                                   22
#define MIXDL1_Gain_labelID                                 23
#define MIXDL2_Gain_labelID                                 24
#define DEFAULT_Gain_labelID                                25
#define DL1_M_G_Tones_labelID                               26
#define DL2_M_G_Tones_labelID                               27
#define Echo_M_G_labelID                                    28
#define SDT_M_G_labelID                                     29
#define VXREC_M_G_VX_DL_labelID                             30
#define UL_M_G_VX_DL_labelID                                31
#define DL1_M_labelID                                       32
#define DL2_M_labelID                                       33
#define MM_UL2_labelID                                      34
#define VX_DL_labelID                                       35
#define Tones_labelID                                       36
#define DL_M_MM_UL2_VX_DL_labelID                           37
#define Echo_M_labelID                                      38
#define VX_UL_labelID                                       39
#define VX_UL_M_labelID                                     40
#define SDT_F_labelID                                       41
#define SDT_F_data_labelID                                  42
#define SDT_Coef_labelID                                    43
#define SDT_Regs_labelID                                    44
#define SDT_M_labelID                                       45
#define DL1_EQ_labelID                                      46
#define DL2_EQ_labelID                                      47
#define DL1_GAIN_out_labelID                                48
#define DL2_GAIN_out_labelID                                49
#define DMIC1_labelID                                       50
#define DMIC1_L_labelID                                     51
#define DMIC1_R_labelID                                     52
#define DMIC2_labelID                                       53
#define DMIC2_L_labelID                                     54
#define DMIC2_R_labelID                                     55
#define DMIC3_labelID                                       56
#define DMIC3_L_labelID                                     57
#define DMIC3_R_labelID                                     58
#define MIC4_labelID                                        59
#define MIC4_L_labelID                                      60
#define MIC4_R_labelID                                      61
#define BT_UL_L_labelID                                     62
#define BT_UL_R_labelID                                     63
#define AMIC_labelID                                        64
#define AMIC_L_labelID                                      65
#define AMIC_R_labelID                                      66
#define EANC_FBK_In_labelID                                 67
#define EANC_FBK_Out_labelID                                68
#define EANC_FBK_L_labelID                                  69
#define EANC_FBK_R_labelID                                  70
#define EchoRef_L_labelID                                   71
#define EchoRef_R_labelID                                   72
#define MM_DL_L_labelID                                     73
#define MM_DL_R_labelID                                     74
#define MM_UL_labelID                                       75
#define AMIC_96_labelID                                     76
#define DMIC0_96_labelID                                    77
#define DMIC1_96_labelID                                    78
#define DMIC2_96_labelID                                    79
#define DMIC_desc_labelID                                   80
#define UL_MIC_48K_labelID                                  81
#define EQ_DL_48K_labelID                                   82
#define EQ_48K_labelID                                      83
#define McPDM_Out1_labelID                                  84
#define McPDM_Out2_labelID                                  85
#define McPDM_Out3_labelID                                  86
#define VX_UL_MUX_labelID                                   87
#define MM_UL2_MUX_labelID                                  88
#define MM_UL_MUX_labelID                                   89
#define XinASRC_DL_VX_labelID                               90
#define ASRC_DL_VX_Coefs_labelID                            91
#define ASRC_DL_VX_Alpha_labelID                            92
#define ASRC_DL_VX_VarsBeta_labelID                         93
#define ASRC_DL_VX_8k_Regs_labelID                          94
#define XinASRC_UL_VX_labelID                               95
#define ASRC_UL_VX_Coefs_labelID                            96
#define ASRC_UL_VX_Alpha_labelID                            97
#define ASRC_UL_VX_VarsBeta_labelID                         98
#define ASRC_UL_VX_8k_Regs_labelID                          99
#define UL_48_8_DEC_labelID                                 100
#define ASRC_DL_VX_16k_Regs_labelID                         101
#define ASRC_UL_VX_16k_Regs_labelID                         102
#define UL_48_16_DEC_labelID                                103
#define XinASRC_DL_MM_labelID                               104
#define ASRC_DL_MM_Coefs_labelID                            105
#define ASRC_DL_MM_Alpha_labelID                            106
#define ASRC_DL_MM_VarsBeta_labelID                         107
#define ASRC_DL_MM_Regs_labelID                             108
#define VX_REC_labelID                                      109
#define VXREC_UL_M_Tones_VX_UL_labelID                      110
#define VX_REC_L_labelID                                    111
#define VX_REC_R_labelID                                    112
#define DL2_M_L_labelID                                     113
#define DL2_M_R_labelID                                     114
#define DL1_M_data_labelID                                  115
#define DL1_M_Coefs_labelID                                 116
#define DL2_M_LR_data_labelID                               117
#define DL2_M_LR_Coefs_labelID                              118
#define SRC_6_LP_COEFS_labelID                              119
#define SRC_6_LP_GAIN_COEFS_labelID                         120
#define SRC_6_HP_COEFS_labelID                              121
#define SRC_3_LP_COEFS_labelID                              122
#define SRC_3_LP_GAIN_COEFS_labelID                         123
#define SRC_3_HP_COEFS_labelID                              124
#define VX_DL_8_48_LP_DATA_labelID                          125
#define VX_DL_8_48_HP_DATA_labelID                          126
#define VX_DL_16_48_LP_DATA_labelID                         127
#define VX_DL_16_48_HP_DATA_labelID                         128
#define VX_UL_48_8_LP_DATA_labelID                          129
#define VX_UL_48_8_HP_DATA_labelID                          130
#define VX_UL_48_16_LP_DATA_labelID                         131
#define VX_UL_48_16_HP_DATA_labelID                         132
#define BT_UL_8_48_LP_DATA_labelID                          133
#define BT_UL_8_48_HP_DATA_labelID                          134
#define BT_UL_16_48_LP_DATA_labelID                         135
#define BT_UL_16_48_HP_DATA_labelID                         136
#define BT_DL_48_8_LP_DATA_labelID                          137
#define BT_DL_48_8_HP_DATA_labelID                          138
#define BT_DL_48_16_LP_DATA_labelID                         139
#define BT_DL_48_16_HP_DATA_labelID                         140
#define ECHO_REF_48_16_LP_DATA_labelID                      141
#define ECHO_REF_48_16_HP_DATA_labelID                      142
#define ECHO_REF_48_8_LP_DATA_labelID                       143
#define ECHO_REF_48_8_HP_DATA_labelID                       144
#define ECHO_REF_DEC_labelID                                145
#define VX_UL_8_TEMP_labelID                                146
#define VX_UL_16_TEMP_labelID                               147
#define UP_DOWN_8_48_labelID                                148
#define UP_DOWN_16_48_labelID                               149
#define SRC_6_LP_48k_labelID                                150
#define SRC_6_HP_labelID                                    151
#define SRC_3_LP_48k_labelID                                152
#define SRC_3_HP_labelID                                    153
#define EARP_48_96_LP_DATA_labelID                          154
#define SRC_48_96_LP_labelID                                155
#define IHF_48_96_LP_DATA_labelID                           156
#define EQ_VX_UL_16K_labelID                                157
#define pAPS_iir1_p23_labelID                               158
#define pAPS_iir1_p45_labelID                               159
#define APS_IIR_Regs_labelID                                160
#define pAPS_core_DL1_p1_labelID                            161
#define pAPS_core_DL1_p23_labelID                           162
#define pAPS_core_DL1_p45_labelID                           163
#define pAPS_core_DL1_r_labelID                             164
#define pAPS_DL2L_core_r_labelID                            165
#define pAPS_DL2R_core_r_labelID                            166
#define pAPS_COIL_core_DL1_p1_labelID                       167
#define pAPS_COIL_core_DL1_p23_labelID                      168
#define pAPS_COIL_core_DL1_p45_labelID                      169
#define pAPS_COIL_core_DL1_r_labelID                        170
#define DL2_L_APS_IIR_p23_labelID                           171
#define DL2_R_APS_IIR_p23_labelID                           172
#define DL2_L_APS_IIR_p45_labelID                           173
#define DL2_R_APS_IIR_p45_labelID                           174
#define DL2_L_APS_CORE_p1_labelID                           175
#define DL2_L_APS_CORE_p23_labelID                          176
#define DL2_L_APS_CORE_p45_labelID                          177
#define DL2_R_APS_CORE_p1_labelID                           178
#define DL2_R_APS_CORE_p23_labelID                          179
#define DL2_R_APS_CORE_p45_labelID                          180
#define DL2_L_APS_COIL_CORE_p1_labelID                      181
#define DL2_L_APS_COIL_CORE_p23_labelID                     182
#define DL2_L_APS_COIL_CORE_p45_labelID                     183
#define pAPS_COIL_DL2L_core_r_labelID                       184
#define DL2_R_APS_COIL_CORE_p1_labelID                      185
#define DL2_R_APS_COIL_CORE_p23_labelID                     186
#define DL2_R_APS_COIL_CORE_p45_labelID                     187
#define pAPS_COIL_DL2R_core_r_labelID                       188
#define DL1_APS_labelID                                     189
#define DL2_L_APS_labelID                                   190
#define DL2_R_APS_labelID                                   191
#define pEANC_p0_labelID                                    192
#define pEANC_p1_labelID                                    193
#define pEANC_p23_labelID                                   194
#define pEANC_p45_labelID                                   195
#define pEANC_reg1_labelID                                  196
#define pEANC_reg2_labelID                                  197
#define pEANC_reg3_labelID                                  198
#define pEANC_r_labelID                                     199
#define DL1_APS_EQ_p23_labelID                              200
#define DL1_APS_EQ_p45_labelID                              201
#define DL2_APS_EQ_p23_labelID                              202
#define DL2_APS_EQ_p45_labelID                              203
#define pDC_EANC_p23_labelID                                204
#define pDC_EANC_r_labelID                                  205
#define pVIBRA1_p0_labelID                                  206
#define pVIBRA1_p1_labelID                                  207
#define pVIBRA1_p23_labelID                                 208
#define pVIBRA1_p45_labelID                                 209
#define pVibra1_pR1_labelID                                 210
#define pVibra1_pR2_labelID                                 211
#define pVibra1_pR3_labelID                                 212
#define pVIBRA1_r_labelID                                   213
#define pVIBRA2_p0_labelID                                  214
#define pVIBRA2_p1_labelID                                  215
#define pVIBRA2_p23_labelID                                 216
#define pVIBRA2_p45_labelID                                 217
#define pCtrl_p67_labelID                                   218
#define pVIBRA2_r_labelID                                   219
#define VIBRA_labelID                                       220
#define PING_labelID                                        221
#define PING_Regs_labelID                                   222
#define UP_48_96_LP_COEFS_labelID                           223
#define AMIC_96_48_data_labelID                             224
#define DOWN_96_48_Coefs_labelID                            225
#define DOWN_96_48_Regs_labelID                             226
#define DMIC0_96_48_data_labelID                            227
#define DMIC1_96_48_data_labelID                            228
#define DMIC2_96_48_data_labelID                            229
#define EANC_FBK_96_48_data_labelID                         230
#define pDC_EANC_r2_labelID                                 231
#define SIO_DMIC_labelID                                    232
#define SIO_PDM_UL_labelID                                  233
#define SIO_BT_VX_UL_labelID                                234
#define SIO_MM_UL_labelID                                   235
#define SIO_MM_UL2_labelID                                  236
#define SIO_VX_UL_labelID                                   237
#define SIO_MM_DL_labelID                                   238
#define SIO_VX_DL_labelID                                   239
#define SIO_TONES_DL_labelID                                240
#define SIO_VIB_DL_labelID                                  241
#define SIO_BT_VX_DL_labelID                                242
#define SIO_PDM_DL_labelID                                  243
#define SIO_MM_EXT_OUT_labelID                              244
#define SIO_MM_EXT_IN_labelID                               245
#define SIO_TDM_OUT_labelID                                 246
#define SIO_TDM_IN_labelID                                  247
#define DMIC_ATC_PTR_labelID                                248
#define MCPDM_UL_ATC_PTR_labelID                            249
#define BT_VX_UL_ATC_PTR_labelID                            250
#define MM_UL_ATC_PTR_labelID                               251
#define MM_UL2_ATC_PTR_labelID                              252
#define VX_UL_ATC_PTR_labelID                               253
#define MM_DL_ATC_PTR_labelID                               254
#define VX_DL_ATC_PTR_labelID                               255
#define TONES_DL_ATC_PTR_labelID                            256
#define VIB_DL_ATC_PTR_labelID                              257
#define BT_VX_DL_ATC_PTR_labelID                            258
#define PDM_DL_ATC_PTR_labelID                              259
#define MM_EXT_OUT_ATC_PTR_labelID                          260
#define MM_EXT_IN_ATC_PTR_labelID                           261
#define TDM_OUT_ATC_PTR_labelID                             262
#define TDM_IN_ATC_PTR_labelID                              263
#define MCU_IRQ_FIFO_ptr_labelID                            264
#define DEBUG_IRQ_FIFO_reg_labelID                          265
#define UP_DOWN_48_96_labelID                               266
#define OSR96_2_labelID                                     267
#define DEBUG_GAINS_labelID                                 268
#define DBG_8K_PATTERN_labelID                              269
#define DBG_16K_PATTERN_labelID                             270
#define DBG_24K_PATTERN_labelID                             271
#define DBG_48K_PATTERN_labelID                             272
#define DBG_96K_PATTERN_labelID                             273
#define UL_VX_UL_48_8K_labelID                              274
#define UL_VX_UL_48_16K_labelID                             275
#define BT_DL_labelID                                       276
#define BT_UL_labelID                                       277
#define BT_DL_8k_labelID                                    278
#define BT_DL_16k_labelID                                   279
#define BT_UL_8k_labelID                                    280
#define BT_UL_16k_labelID                                   281
#define MM_EXT_IN_labelID                                   282
#define MM_EXT_IN_L_labelID                                 283
#define MM_EXT_IN_R_labelID                                 284
#define ECHO_REF_48_16_WRAP_labelID                         285
#define ECHO_REF_48_8_WRAP_labelID                          286
#define BT_UL_16_48_WRAP_labelID                            287
#define BT_UL_8_48_WRAP_labelID                             288
#define BT_DL_48_16_WRAP_labelID                            289
#define BT_DL_48_8_WRAP_labelID                             290
#define VX_DL_16_48_WRAP_labelID                            291
#define VX_DL_8_48_WRAP_labelID                             292
#define VX_UL_48_16_WRAP_labelID                            293
#define VX_UL_48_8_WRAP_labelID                             294
#define APS_DL1_IRQs_WRAP_labelID                           295
#define APS_DL2_L_IRQs_WRAP_labelID                         296
#define APS_DL2_R_IRQs_WRAP_labelID                         297
#define ATC_NULL_BUFFER_labelID                             298
#define MEM_INIT_hal_mem_labelID                            299
#define MEM_INIT_write_mem_labelID                          300
#define MEM_INIT_regs_labelID                               301
#define GAIN_0DB_labelID                                    302

#endif /* _ABE_INITXXXX_LABELS_H_ */
